function Controller() {
    function getMapDirection() {
        var sourceAdd = $.sourceLocationEditText.value;
        var destAdd = $.destLocationEditText.value;
        getRoute(sourceAdd, destAdd);
    }
    function getRoute(sourceAdd, destAdd) {
        var url = "http://maps.googleapis.com/maps/api/directions/json?origin=" + sourceAdd + "&destination=" + destAdd + "&sensor=false";
        Ti.API.info(TAG, "End Point is " + url);
        var client = Ti.Network.createHTTPClient({
            onload: function() {
                Ti.API.info("Received text: " + this.responseText);
                drawRoute(this.responseText);
            },
            onerror: function(e) {
                hideIndicator();
                Ti.API.debug(e.error);
                alert("error");
            },
            timeout: 5e3
        });
        client.open("GET", url);
        showIndicator();
        client.send();
    }
    function drawRoute(res) {
        var response = JSON.parse(res);
        var points = [], status = response.status;
        var pois = [];
        var status_message = status;
        Ti.API.info(TAG, ">>> status_message is " + status_message);
        alert("status : " + status_message);
        if ("OK" != status_message) {
            hideIndicator();
            showDirectionErrorDialog("map err no route", "googlemap error");
        } else {
            var steps = response.routes[0].legs[0].steps, totalSteps = steps.length;
            response.routes[0].legs[0].end_address;
            Ti.API.info(TAG, ">>> totalSteps is " + totalSteps);
            for (var i = 0; totalSteps > i; i++) {
                decodedPolyline = decodeLine(steps[i].polyline.points);
                response.routes[0].legs[0].start_address;
                var directionStep = steps[i].html_instructions;
                var time = steps[i].distance.text;
                directin_step.push(directionStep);
                time_step.push(time);
                startLatitude = steps[i].start_location.lat;
                startLongitude = steps[i].start_location.lng;
                pois.push({
                    lat: startLatitude,
                    lon: startLongitude
                });
                Ti.API.info(TAG, ">>> latitude: " + startLatitude);
                Ti.API.info(TAG, ">>> longitude: " + startLongitude);
                for (var j = 0; decodedPolyline.length > j; j++) null != decodedPolyline[j] && points.push({
                    latitude: decodedPolyline[j][0],
                    longitude: decodedPolyline[j][1]
                });
            }
            var route = Alloy.Globals.Map.createRoute({
                points: points,
                color: "blue",
                width: 6
            }), startAnnotation = Alloy.Globals.Map.createAnnotation({
                pincolor: Alloy.Globals.Map.ANNOTATION_RED,
                latitude: points[0].latitude,
                longitude: points[0].longitude,
                title: $.sourceLocationEditText.value
            }), endAnnotation = Alloy.Globals.Map.createAnnotation({
                pincolor: Alloy.Globals.Map.ANNOTATION_GREEN,
                latitude: points[points.length - 1].latitude,
                longitude: points[points.length - 1].longitude,
                title: $.destLocationEditText.value
            });
            var poiCenter = {};
            var delta = .02;
            var minLat = pois[0].lat, maxLat = pois[0].lat, minLon = pois[0].lon, maxLon = pois[0].lon;
            for (var i = 0; pois.length - 1 > i; i++) {
                minLat = Math.min(pois[i + 1].lat, minLat);
                maxLat = Math.max(pois[i + 1].lat, maxLat);
                minLon = Math.min(pois[i + 1].lon, minLon);
                maxLon = Math.max(pois[i + 1].lon, maxLon);
            }
            var deltaLat = maxLat - minLat;
            var deltaLon = maxLon - minLon;
            delta = Math.max(deltaLat, deltaLon);
            deltaLat > deltaLon ? delta = delta : delta += .3;
            poiCenter.lat = maxLat - parseFloat((maxLat - minLat) / 2);
            poiCenter.lon = maxLon - parseFloat((maxLon - minLon) / 2);
            $.mapView.region = {
                latitude: poiCenter.lat,
                longitude: poiCenter.lon,
                latitudeDelta: delta,
                longitudeDelta: delta
            };
            $.mapView.addRoute(route);
            $.mapView.addAnnotation(startAnnotation);
            $.mapView.addAnnotation(endAnnotation);
            hideIndicator();
        }
    }
    function decodeLine(encoded) {
        var len = encoded.length;
        var index = 0;
        var array = [];
        var lat = 0;
        var lng = 0;
        while (len > index) {
            var b;
            var shift = 0;
            var result = 0;
            do {
                b = encoded.charCodeAt(index++) - 63;
                result |= (31 & b) << shift;
                shift += 5;
            } while (b >= 32);
            var dlat = 1 & result ? ~(result >> 1) : result >> 1;
            lat += dlat;
            shift = 0;
            result = 0;
            do {
                b = encoded.charCodeAt(index++) - 63;
                result |= (31 & b) << shift;
                shift += 5;
            } while (b >= 32);
            var dlng = 1 & result ? ~(result >> 1) : result >> 1;
            lng += dlng;
            array.push([ 1e-5 * lat, 1e-5 * lng ]);
        }
        return array;
    }
    function showDirectionErrorDialog(str, ttl) {
        var alertDialog = Titanium.UI.createAlertDialog({
            message: str,
            title: ttl,
            persistent: true,
            ok: "Ok"
        });
        alertDialog.show();
    }
    function showIndicator() {
        if (!showingIndicator) {
            progressIndicator = Titanium.UI.Android.createProgressIndicator({
                message: "Loading",
                location: Ti.UI.Android.PROGRESS_INDICATOR_DIALOG,
                type: Ti.UI.Android.PROGRESS_INDICATOR_INDETERMINANT,
                cancelable: false
            });
            progressIndicator.show();
            showingIndicator = true;
        }
    }
    function hideIndicator() {
        if (null == progressIndicator || false == showingIndicator) return;
        progressIndicator.hide();
        showingIndicator = false;
        progressIndicator = null;
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "index";
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        backgroundColor: "white",
        layout: "vertical",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    $.__views.sourceLocationEditText = Ti.UI.createTextField({
        width: "70%",
        height: "37dip",
        hintText: "Eneter source location",
        left: "45dip",
        color: "black",
        paddingLeft: 12,
        autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_NONE,
        autocorrect: false,
        font: {
            fontFamily: "Arial",
            fontSize: "12dip",
            fontStyle: "normal",
            fontWeight: "normal"
        },
        id: "sourceLocationEditText"
    });
    $.__views.index.add($.__views.sourceLocationEditText);
    $.__views.destLocationEditText = Ti.UI.createTextField({
        width: "70%",
        height: "37dip",
        hintText: "Eneter destination location",
        left: "45dip",
        color: "black",
        paddingLeft: 12,
        autocapitalization: Titanium.UI.TEXT_AUTOCAPITALIZATION_NONE,
        autocorrect: false,
        font: {
            fontFamily: "Arial",
            fontSize: "12dip",
            fontStyle: "normal",
            fontWeight: "normal"
        },
        id: "destLocationEditText"
    });
    $.__views.index.add($.__views.destLocationEditText);
    $.__views.getDirectionBtn = Ti.UI.createButton({
        title: "Get Direction",
        width: "20%",
        height: "37dip",
        right: "5dp",
        font: {
            fontFamily: "Arial",
            fontSize: "12dip",
            fontStyle: "normal",
            fontWeight: "bold"
        },
        id: "getDirectionBtn"
    });
    $.__views.index.add($.__views.getDirectionBtn);
    getMapDirection ? $.__views.getDirectionBtn.addEventListener("click", getMapDirection) : __defers["$.__views.getDirectionBtn!click!getMapDirection"] = true;
    $.__views.mapView = Alloy.Globals.Map.createView({
        animate: true,
        regionFit: true,
        mapType: Alloy.Globals.Map.NORMAL_TYPE,
        id: "mapView",
        ns: "Alloy.Globals.Map"
    });
    $.__views.index.add($.__views.mapView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var TAG = "sampleMap";
    var progressIndicator;
    var showingIndicator = false;
    var directin_step = [];
    var time_step = [];
    var code = Alloy.Globals.Map.isGooglePlayServicesAvailable();
    code != Alloy.Globals.Map.SUCCESS && alert("Google Play Services is not installed/updated/available");
    $.index.open();
    __defers["$.__views.getDirectionBtn!click!getMapDirection"] && $.__views.getDirectionBtn.addEventListener("click", getMapDirection);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;